// memtest.cpp : Defines the entry point for the DLL application.
//

#include "memtest.h"
#ifdef MEMTEST_STATIC
#include "sprtf.h"
#else
#define  sprtf printf
#endif

// This is an example of an exported variable
MEMTEST_API int nMemtest=0;

PVOID pmtVoid1 = 0;
PVOID pmtVoid2 = 0;
PVOID pmtVoid3 = 0;
PVOID pmtVoid4 = 0;
PVOID pmtVoid5 = 0;

#define  SHOWMEM1(a) sprtf( "%s(%d): using " a , __FILE__, __LINE__ + 1 )
#define  SHOWMEM2(a) sprintf((char *)a, " Addr: %p", a); sprtf( " %s\n", a)

VOID mt_Allocate_using_new(VOID)
{
   SHOWMEM1( "new BYTE[1234]" );
   pmtVoid1 = new BYTE[1234];
   SHOWMEM2(pmtVoid1);
}
VOID mt_Allocate_using_malloc(VOID)
{
   SHOWMEM1( "malloc 4567" );
   pmtVoid2 = malloc(4567);
   SHOWMEM2(pmtVoid2);
}

VOID mt_Allocate_using_LocalAlloc(VOID)
{
   SHOWMEM1( "LocalAlloc 2345" );
   pmtVoid3 = LocalAlloc( LPTR, 2345 );
   SHOWMEM2(pmtVoid3);
}
VOID mt_Allocate_using_VirtualAlloc(VOID)
{
   SHOWMEM1( "VirtualAlloc 3 MB" );
   pmtVoid4 = VirtualAlloc( NULL, 3 * 1024, MEM_COMMIT, PAGE_READWRITE );
   SHOWMEM2(pmtVoid4);
}

VOID mt_Allocate_using_GlobalAlloc(VOID)
{
   SHOWMEM1( "GlobalAlloc 3456" );
   pmtVoid5 = GlobalAlloc( GPTR, 3456 );
   SHOWMEM2(pmtVoid5);
}

VOID mt_Allocate_Test_Memory( VOID )
{
   mt_Allocate_using_new();
   mt_Allocate_using_malloc();
   mt_Allocate_using_LocalAlloc();
   mt_Allocate_using_GlobalAlloc();
   mt_Allocate_using_VirtualAlloc();
}


// This is an example of an exported function.
MEMTEST_API int fnMemtest(void)
{
   mt_Allocate_Test_Memory();
	return 42;
}

// This is the constructor of a class that has been exported.
// see memtest.h for the class definition
CMemtest::CMemtest()
{ 
	return; 
}

