// memtestStatic.cpp : Static library
//

#include "memtestStatic.h"
#include "sprtf.h"

static PVOID psVoid1 = 0;
static PVOID psVoid2 = 0;
static PVOID psVoid3 = 0;
static PVOID psVoid4 = 0;
static PVOID psVoid5 = 0;

#define  SHOWMEM1(a) sprtf( "%s(%d): using " a , __FILE__, __LINE__ + 1 )
#define  SHOWMEM2(a,b) sprintf((char *)a, "%p %s", a, b); sprtf( " %s\n", a)

static VOID mt_Allocate_using_new(VOID)
{
   SHOWMEM1( "new BYTE[1234] " );
   psVoid1 = new BYTE[1234];
   SHOWMEM2(psVoid1,"new");
}
static VOID mt_Allocate_using_malloc(VOID)
{
   SHOWMEM1( "malloc 4567 " );
   psVoid2 = malloc(4567);
   SHOWMEM2(psVoid2,"malloc");
}

static VOID mt_Allocate_using_LocalAlloc(VOID)
{
   SHOWMEM1( "LocalAlloc 2345 " );
   psVoid3 = LocalAlloc( LPTR, 2345 );
   SHOWMEM2(psVoid3,"LocalAlloc");
}
static VOID mt_Allocate_using_VirtualAlloc(VOID)
{
   SHOWMEM1( "VirtualAlloc 3 MB " );
   psVoid4 = VirtualAlloc( NULL, 3 * 1024, MEM_COMMIT, PAGE_READWRITE );
   SHOWMEM2(psVoid4,"VirtualAlloc");
}

static VOID mt_Allocate_using_GlobalAlloc(VOID)
{
   SHOWMEM1( "GlobalAlloc 3456 " );
   psVoid5 = GlobalAlloc( GPTR, 3456 );
   SHOWMEM2(psVoid5,"GlobalAlloc");
}

static VOID mt_Allocate_Test_Memory( VOID )
{
   sprtf( "Allocations made in STATIC module: %s ...\n", __FILE__ );
   mt_Allocate_using_new();
   mt_Allocate_using_malloc();
   mt_Allocate_using_LocalAlloc();
   mt_Allocate_using_GlobalAlloc();
   mt_Allocate_using_VirtualAlloc();
}


// This is an example of an exported function.
int fnMemTestStatic(void)
{
   mt_Allocate_Test_Memory();
	return 42;
}

// eof - memtestStatic.cpp
